#include <errno.h>
#include <sys/acl.h>

int acl_calc_mask (acl_t *acl_p)
{
	acl_entry_t	acle;
	acl_entry_t mask_p= NULL;
	acl_perm_t mperm = 0;
		
	CHECK_ACL_VALID ((*acl_p), -1);
	
	for (acle = (*acl_p)->acl_faclep; acle; acle = acle->acle_next) {
		switch (acle->acle_tag_type) {
		case ACL_USER_OBJ:
		case ACL_OTHER_OBJ:
			break;
		case ACL_GROUP:
		case ACL_GROUP_OBJ:
		case ACL_USER:
			mperm |= acle->acle_perms; 
			break;
		case ACL_MASK:
			mask_p= acle;
			break;
		default:
			errno = EINVAL;
			return -1;
		}
	}
	if(mask_p == NULL) { /* if no mask entry in acl_p */
		if (acl_create_entry (acl_p, &mask_p) != 0)
			return -1;
		if (acl_set_tag_type (mask_p, ACL_MASK) != 0)
			return -1;
		if (acl_set_mode (mask_p, ACL_ABSOLUTE_ENTRY) != 0)
			return -1;
	}
	if (acl_set_permset (mask_p, &mperm) != 0)
		return -1;
	return 0;
}






