#include <errno.h>
#include <string.h>
#include <sys/acl.h>

int acl_create_entry (acl_t *acl_p, acl_entry_t *entry_p) 
{
	acl_t acl;

	if (!acl_p) {
		errno = EINVAL;
		return -1;
	}
	acl = *acl_p;
	CHECK_ACL_VALID (acl, -1);
	if (acl->acl_free) {
		*entry_p = acl->acl_free;
		acl->acl_free = acl->acl_free->acle_next;
	} else {
		*entry_p = (acl_entry_t) malloc (sizeof (struct acl_entry));
		if (!(*entry_p)) {
			errno = ENOMEM;
			return -1;
		}
		memset ((void *) (*entry_p), 0, sizeof (struct acl_entry));
		acl->acl_acle_count++;
	}
	(*entry_p)->acle_valid = VALID_ACL_ENTRY;
	(*entry_p)->acle_aclp = acl;
	(*entry_p)->acle_prev = acl->acl_laclep;
	(*entry_p)->acle_next = NULL;
	if (acl->acl_laclep)
		acl->acl_laclep->acle_next = *entry_p;
	if (!acl->acl_faclep)
		acl->acl_faclep = *entry_p;
	acl->acl_laclep = *entry_p;
	acl->acl_used_acle++;
	return 0;
}
